# -*- coding: utf-8 -*- #
# Copyright 2019 Google LLC. All Rights Reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
"""The gcloud events sources group."""

from __future__ import absolute_import
from __future__ import division
from __future__ import unicode_literals

from googlecloudsdk.calliope import base
from googlecloudsdk.command_lib.kuberun import flags


class Sources(base.Group):
  """View available Event Type sources.

  This set of commands can be used to view Event Type sources.
  """

  detailed_help = {
      'EXAMPLES':
          """
          To list available event type sources, run:

            $ {command} list
      """,
  }

  @staticmethod
  def Args(parser):
    flags.ClusterConnectionFlags().AddToParser(parser)
